local _, L = ...;

------Slashcommands
SLASH_RELOADUI1 = "/rl"
SLASH_RELOADUI2 = "/re"
SlashCmdList.RELOADUI = ReloadUI

SLASH_FRAMESTK1 = "/fs"; -- new slash command for showing framestack tool
	SlashCmdList.FRAMESTK = function()
		LoadAddOn("Blizzard_DebugTools");
		FrameStackTooltip_Toggle();
end

SLASH_FPS1 = "/fps"; -- new slash command for showing fps tool
SlashCmdList.FPS = function()
ToggleFramerate();	
end

SLASH_TNS1 = "/tns"
SlashCmdList.TNS =   function() TNS_Command() end



-------Warm welcomes and chat improvement
function Print(...)
    local hex = "00ccff";
    local prefix = string.format("|cff%s%s|r", hex:upper(), "Tweaksn Stuff:");	
    DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, ...));
end

Print(L.WarmWelcomes, UnitName("player").."!");


for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false);
end



----------------------
inLockdown = InCombatLockdown()



----------------------------Timer Section

local timer = 0 


local f = CreateFrame("Frame")
f:SetScript("OnUpdate", function(self, elapsed)
       timer = timer + elapsed
    if timer >= 0.5 then                                  ---interval (in seconds)
        
		timer = 0
		
		
		
		durabilitycheck()
		inLockdown = InCombatLockdown()
		if rounded<=30
		then repair_bool=true 
		HS_TextMessage(L.DurabilityWarning)	
		else	
		HS_TextMessage("")		
		end
    end   
		
		
end)


----------------------------Timer section


durabilitycheck = function() 

function scanAll()
	equipped,bags,cost,per,current,maximum,total,_ = 0,0,0,1;
	_curr,_max,_per,_perSlot,_AvPercent = 0,0,1,nil,1;

	for slot=1, 18 do
		if (GetInventoryItemID("player", slot)) then
			current,maximum = GetInventoryItemDurability(slot); -- durability values
			if (current) and (maximum>0) and (current<maximum) then
								equipped = equipped + tonumber(cost or 0);
				_curr,_max = _curr+current,_max+maximum;
				per = current/maximum;
				if (per<_per) then
					_per,_perSlot = per,slot;
				end
			end
		end
	end

	if (_max>0) then
		_AvPercent = _curr/_max;
	end

	return total,equipped,bags,_AvPercent*100,_per*100,_perSlot;

	end

	total,equipped,bags,_AvPercent,_per,_perSlot = scanAll()


	rounded = floor(_AvPercent)

	--print(rounded)


end


function HS_TextMessage(message)

	TextFrame.text:SetText(message);
	TextFrame.text:SetTextColor(1, 0, 0, 1);
	TextFrame:SetAlpha(1);
	TextFrame:Show();
	if TNSDataChar.Active==false then 
		TextFrame:Hide();

	else
		if   TNSDataChar.Combat==true then 
			if inLockdown==true then TextFrame:Hide(); end  --and TNS.Settings.CombatButton==true 
		end
		HS_TextFrameTime = GetTime();
	end


end

TextFrame = CreateFrame("Frame");
TextFrame:ClearAllPoints();
TextFrame:SetHeight(300);
TextFrame:SetWidth(400);
TextFrame:SetScript("OnUpdate", HS_TextFrame_OnUpdate)
TextFrame:Hide();
TextFrame.text = TextFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
TextFrame.text:SetFont("Fonts\\DAMAGE.ttf",14,"OUTLINE");
TextFrame.text:SetAllPoints();
TextFrame:SetPoint("TOP", 0, 60);

HS_TextFrameTime = 1;


------------------------------------------------
---------------	 Option Settings ---------------
------------------------------------------------


local addOnName = ...
TNS = {} 


local vars = CreateFrame("FRAME") -- Variables
vars:RegisterEvent("ADDON_LOADED") --RegisterAddonLoad


-- Load Variables
vars:SetScript("OnEvent",function(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == "Tweaks n Stuff" then
        if TNSDataChar == nil then
            TNSDataChar = {
        
				Active = true, -- Toggle Active
				Combat = false, -- Toggle Active
            
            }
        else

            if TNSDataChar.Active == nil then TNSDataChar.Active = true end -- Toggle Active
			if TNSDataChar.Combat == nil then TNSDataChar.Combat = false end -- Toggle Combat
        end
        TNS:Options() -- TNS Options
    end
end)


-- TNS Options
function TNS:Options()

    local Configurationpanel = CreateFrame("FRAME", "Configurationpanel")
    Configurationpanel.name = addOnName
	InterfaceOptions_AddCategory(Configurationpanel)
	
	-------------------------- main Configurationpanel
	-- Title
    local title = Configurationpanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addOnName)
	
	local sometext = Configurationpanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	sometext:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	sometext:SetText("Still work in progress!")
							  

    -- Active CheckButton
    local check_Active = CreateFrame("CheckButton", "check_Active", Configurationpanel, "ChatConfigCheckButtonTemplate")
    check_Active:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -3, -45)
    check_Active:SetWidth(30)
	check_Active:SetHeight(30)
	check_Active.tooltip = L.EnabledDescription
    _G[check_Active:GetName().."Text"]:SetText(L.UI_Enabled)
    check_Active:SetChecked(TNSDataChar.Active)
    check_Active:SetScript("OnClick",function()
        TNSDataChar.Active = check_Active:GetChecked()
	end)   

	-- Combat CheckButton
	local check_Combat = CreateFrame("CheckButton", "check_Combat", Configurationpanel, "ChatConfigCheckButtonTemplate")
	check_Combat:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -3, -75)
	check_Combat:SetWidth(30)
	check_Combat:SetHeight(30)
	check_Combat.tooltip = L.CombatHideDescription;
	_G[check_Combat:GetName().."Text"]:SetText(L_CombatHideEnabled)
	check_Combat:SetChecked(TNSDataChar.Combat)
	check_Combat:SetScript("OnClick",function()
		TNSDataChar.Combat= check_Combat:GetChecked()
	end)   



	
	--[[local TextSizeSlider = CreateFrame("Slider", "TNS_TrivialDamageSlider", Configurationpanel, "OptionsSliderTemplate");
	TextSizeSlider:SetPoint("TOPLEFT", 30 , -150);
	TextSizeSlider.tooltip = "FILLER TOOLTIP TEXT";
	TextSizeSlider:SetScript("OnValueChanged",TNS_Option_SetTrivialDamage);
	--TextSizeSlider:SetText("Text")
	--TextSizeSlider:SetText("High ");
	--TextSizeSlider:SetText("Low");
	TextSizeSlider:SetMinMaxValues(.5,10);
	TextSizeSlider:SetValueStep(.5);
	TextSizeSlider:SetValue("5");
	--Option_SetTrivialDamageText("5");]]--
	
	
	------------------info Configurationpanel

	local infopanel = CreateFrame("Frame")
	infopanel.name = "Info"
	infopanel.parent = addOnName

	InterfaceOptions_AddCategory(infopanel)


	local infotext = infopanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	infotext:SetPoint("TOPLEFT", 16, -16)
	infotext:SetText("Author: Mma")

                 
                  
end

-------------------------------Slash Command

function TNS_Command()                                --Buggy needs to be commanded 3x
	InterfaceOptionsFrame_OpenToCategory(addOnName);
	InterfaceOptionsFrame_OpenToCategory(addOnName);
	InterfaceOptionsFrame_OpenToCategory(addOnName);
end